#include "wot.h"
#include "chdefine.h"
#include "xbm/bitmaps.h"
#include "map.h"

void PutOnRandomHevstone(){
    int i,j,x,y,stone_n,percent;
    char c;

    stone_n=0;
    for(i=0;i<map_size_x;i++){
	for(j=TILE_NUMBER_Y/2;j<map_size_y+TILE_NUMBER_Y/2;j++){
	    switch(map[i][j]){
	    case HEVSTONE_C:
		c=SPACE_C;
		break;
	    case HEVSTONE_BC:
		c=LBOX_C;
		break;
	    case HEVSTONE_SC:
	    case HEVSTONE_L_SC:
	    case HEVSTONE_F_SC:
		c=SBOX_C;
		break;
	    default:
		continue;
	    }
	    map[i][j]=c;
	    stone_n++ ;
	}
    }

    if(stone_n<4)
	stone_n+=4;
    
    Random(-1);/**/
    for(i=0;i<stone_n;i++){
	while(1){
	    x=Random(map_size_x);
	    y=Random(map_size_y);
	    switch(map[x][y+(TILE_NUMBER_Y/2)]){
	    case MINESPACE_C:
	    case SPACE_C:
		percent=3;
		c=HEVSTONE_C;
		break;
	    case SBOX_C:
	    case LIGHT_SC:
	    case FIRE_SC:
		percent=60;
		c=HEVSTONE_SC;
		break;
	    case DRINK_C:
	    case EGG_C:
	    case MINE_C:
	    case SWORD_C:
		percent=5;
		c=HEVSTONE_C;
		break;
	    case LBOX_C:
		percent=25;
		c=HEVSTONE_BC;
		break;
	    case SWORD_BC:
	    case MINE_BC:
	    case SHIELDF_BC:
	    case SHIELDL_BC:
	    case DRINK_BC:
	    case EGG_BC:
		percent=15;
		c=HEVSTONE_BC;
		break;
	    default:
		percent=0;
	    }
	    if(percent>=Random(100)+1){
		map[x][y+(TILE_NUMBER_Y/2)]=c;
		break;
	    }
	}/*while*/

		
    }/*for*/
    
}


    
void MapInitialize(s)
int s;
{
    int i,j;
    char **mapdata;
    struct player_origin playerorigin;

    switch(s){

    case 1:
	mapdata=mapdata1;
	playerorigin=playerorigin1;
	break;
    case 2:
	mapdata=mapdata2;
	playerorigin=playerorigin2;
	break;
    case 3:
	mapdata=mapdata3;
	playerorigin=playerorigin3;
	break;
    case 4:
	mapdata=mapdata4;
	playerorigin=playerorigin4;
	break;
    case 5:
	mapdata=mapdata5;
	playerorigin=playerorigin5;
	break;
    case 6:
	mapdata=mapdata6;
	playerorigin=playerorigin6;
	break;
    case 7:
	mapdata=mapdata7;
	playerorigin=playerorigin7;
	break;
    case 8:
	mapdata=mapdata8;
	playerorigin=playerorigin8;
	break;
	
    default:
	printf("\nThis map is not exist. \n");
	exit(1);
    }
    
    
    for (j=0;j<MAP_SIZE_Y;j++)
	for(i=0;i<MAP_SIZE_X;i++)
	    map[j][i]=HARDBLOCK_C;

    map_size_x=strlen(mapdata[0]);
    for (j=0;j<MAP_SIZE_Y;j++){
	if(!strcmp(mapdata[j],"end"))
	    break;
	for(i=0;i<map_size_x;i++)
	    map[i][j+TILE_NUMBER_Y/2]=mapdata[j][i];
    }
    map_size_y=j+1;
    
    location_x[0]=playerorigin.p1_origin_x;
    location_y[0]=playerorigin.p1_origin_y;
    location_x[1]=playerorigin.p2_origin_x;
    location_y[1]=playerorigin.p2_origin_y;

    PutOnRandomHevstone();
}

void Initialize(){

    graphic_number[ SPACE_C     -0x20 ]= 0;
    graphic_number[ BLOCK_C     -0x20 ]= 15;

    graphic_number[ SWORD_C     -0x20 ]= 1;
    graphic_number[ SBOX_C      -0x20 ]= 2;
    graphic_number[ LBOX_C      -0x20 ]= 4;
    graphic_number[ MINE_C      -0x20 ]= 5;
    graphic_number[ SHIELDF_C   -0x20 ]= 6;
    graphic_number[ SHIELDL_C   -0x20 ]= 7;
    graphic_number[ MOONSTONE_C -0x20 ]= 8;
    graphic_number[ EYESTONE_C  -0x20 ]= 9;
    graphic_number[ DRINK_C     -0x20 ]= 10;
    graphic_number[ EGG_C       -0x20 ]= 11;
    graphic_number[ EXIT_C      -0x20 ]= 12;
    graphic_number[ HEVSTONE_C  -0x20 ]= 13;
    graphic_number[ POWER_C     -0x20 ]= 14;
    graphic_number[ SWORD_BC    -0x20 ]= 4;
    graphic_number[ SBOX_BC     -0x20 ]= 4;
    graphic_number[ LBOX_BC     -0x20 ]= 4;
    graphic_number[ MINE_BC     -0x20 ]= 4;
    graphic_number[ SHIELDF_BC  -0x20 ]= 4;
    graphic_number[ SHIELDL_BC  -0x20 ]= 4;
    graphic_number[ MOONSTONE_BC-0x20 ]= 4;
    graphic_number[ EYESTONE_BC -0x20 ]= 4;
    graphic_number[ DRINK_BC    -0x20 ]= 4;
    graphic_number[ EGG_BC      -0x20 ]= 4;
    graphic_number[ EXIT_BC     -0x20 ]= 4;
    graphic_number[ HEVSTONE_BC -0x20 ]= 4;
    graphic_number[ POWER_BC    -0x20 ]= 4;
    
    graphic_number[ HARDBLOCK_C -0x20 ]= 15;/*?*/
    graphic_number[ POWERIMI_C  -0x20 ]= 14;
    graphic_number[ EGG1_C      -0x20 ]= 11;
    graphic_number[ EGG2_C      -0x20 ]= 11;
    graphic_number[ HEVSTONE_SC -0x20 ]= 2;
    graphic_number[ BLOCKMINE_C -0x20 ]= 15;
    graphic_number[ BLOCKTHROW_C-0x20 ]= 15;
    graphic_number[ LIGHT_SC    -0x20 ]= 2;
    graphic_number[ FIRE_SC     -0x20 ]= 2;
    graphic_number[ HEVSTONE_L_SC-0x20]= 2;
    graphic_number[ HEVSTONE_F_SC-0x20]= 2;
    graphic_number[ MINESPACE_C  -0x20]= 0;

    graphic_number[ NOTHING	 -0x20]= 16;


    

    object_xbm[0] = space_bits;
    object_xbm[1] = sword_bits;
    object_xbm[2] = sbox_bits;
    object_xbm[3] = nothing_bits;
    object_xbm[4] = lbox_bits;
    object_xbm[5] = mine_bits;
    object_xbm[6] = shieldf_bits;
    object_xbm[7] = shieldl_bits;
    object_xbm[8] = moonstone_bits;
    object_xbm[9] = eyestone_bits;
    object_xbm[10] = drink_bits;
    object_xbm[11] = egg_bits;
    object_xbm[12] = exit_bits;
    object_xbm[13] = hevstone_bits;
    object_xbm[14] = power_bits;
    object_xbm[15] = block_bits;
    object_xbm[16] = space_bits;
    object_xbm[17] = minespace_bits;
    object_xbm[18] = minespace2_bits;
    
    magic_xbm[0] = magic_light_bits;
    magic_xbm[1] = magic_fire_bits;
    
    charactor_xbm     [0] = man1_bits;
    charactor_mask_xbm[0] = man1mask_bits;
    charactor_mask2_xbm[0]= man1mask2_bits;
    
    charactor_xbm     [1] = man2_bits;
    charactor_mask_xbm[1] = man2mask_bits;
    charactor_mask2_xbm[1]= man2mask2_bits;
    
    charactor_xbm     [2] = mandead1_bits;
    charactor_mask_xbm[2] = mandead1_mask_bits;
    charactor_mask2_xbm[2]= mandead1_mask2_bits;
    
    charactor_xbm     [3] = mandead2_bits;
    charactor_mask_xbm[3] = mandead2_mask_bits;
    charactor_mask2_xbm[3]=mandead2_mask2_bits;
    
    charactor_xbm     [4] = manbomb_bits;
    charactor_mask_xbm[4] = manbomb_mask_bits;
    charactor_mask2_xbm[4]= manbomb_mask2_bits;
    
    number_xbm[0]=one_bits;
    number_xbm[1]=two_bits;
    number_xbm[2]=three_bits;
    number_xbm[3]=four_bits;
    number_xbm[4]=five_bits;
    number_xbm[5]=six_bits;
    number_xbm[6]=seven_bits;
    number_xbm[7]=eight_bits;

}

void InitializeManState(){
    int p;
    for (p=0;p<PLAYERS;p++){
	item[p]=NOTHING;
	magic[p]=NOTHING;
	hevstone[p]=0;
	hp[p]=16;
	maxhp[p]=16;
	str[p]=4;
	body[p]=1;
	charactor_number[p]=0;
	movecheck[p]=0;
	keyrepeat_mode[p]=0;
	bright_mode[p]=0;
    }    
}

