/*  ꥽*/
#include <stdio.h>
#include <stdlib.h>      /* char *getenv(); */
#include <malloc.h>
#include <pwd.h>
#include <strings.h>
    
#include "wot.h"
#include "patchlevel.h"
    
#include <X11/Xresource.h>
  
static int number_of_option = 57;
static XrmOptionDescRec option_table[] =
{
    {"-display",     "*display",    	XrmoptionSepArg, (caddr_t) NULL},
    {"-display1",    ".one.display",	XrmoptionSepArg, (caddr_t) NULL},
    {"-display2",    ".two.display",	XrmoptionSepArg, (caddr_t) NULL},
    {"-d",	     "*display",	XrmoptionSepArg, (caddr_t) NULL},
    {"-d1",	     ".one.display",	XrmoptionSepArg, (caddr_t) NULL},
    {"-d2",	     ".two.display",	XrmoptionSepArg, (caddr_t) NULL},
    {"-geometry",    "*geometry",	XrmoptionSepArg, (caddr_t) NULL},
    {"-geometry1",   ".one.geometry",	XrmoptionSepArg, (caddr_t) NULL},
    {"-geometry2",   ".two.geometry",	XrmoptionSepArg, (caddr_t) NULL},
    {"-g",	     "*geometry",	XrmoptionSepArg, (caddr_t) NULL},
    {"-g1",	     ".one.geometry",	XrmoptionSepArg, (caddr_t) NULL},
    {"-g2",	     ".two.geometry",	XrmoptionSepArg, (caddr_t) NULL},
    
    {"-foreground",  "*foreground",	XrmoptionSepArg, (caddr_t) NULL},
    {"-foreground1", ".one.foreground",	XrmoptionSepArg, (caddr_t) NULL},
    {"-foreground2", ".two.foreground",	XrmoptionSepArg, (caddr_t) NULL},
    {"-fg",          "*foreground",	XrmoptionSepArg, (caddr_t) NULL},
    {"-fg1",	     ".one.foreground",	XrmoptionSepArg, (caddr_t) NULL},
    {"-fg2",	     ".two.foreground",	XrmoptionSepArg, (caddr_t) NULL},
    {"-background",  "*background",	XrmoptionSepArg, (caddr_t) NULL},
    {"-background1", ".one.background",	XrmoptionSepArg, (caddr_t) NULL},
    {"-background2", ".two.background",	XrmoptionSepArg, (caddr_t) NULL},
    {"-bg",          "*background",	XrmoptionSepArg, (caddr_t) NULL},
    {"-bg1",	     ".one.background",	XrmoptionSepArg, (caddr_t) NULL},
    {"-bg2",	     ".two.background", XrmoptionSepArg, (caddr_t) NULL},
    {"-rv",	     "*reverseVideo",	XrmoptionNoArg,  (caddr_t) "True"},
    {"-rv1",	     ".one.reverseVideo",XrmoptionNoArg, (caddr_t) "True"},
    {"-rv2",	     ".two.reverseVideo",XrmoptionNoArg, (caddr_t) "True"},
    {"-i",	     ".iconic",     	XrmoptionNoArg,  (caddr_t) "True"},
    {"-iconic",	     ".iconic",     	XrmoptionNoArg,  (caddr_t) "True"},
    
    {"-handicap",    ".handicap",   XrmoptionSepArg, (caddr_t) NULL},
    {"-size",	     ".size",       XrmoptionSepArg, (caddr_t) NULL},
    {"-map",	     ".map",        XrmoptionSepArg, (caddr_t) NULL},
    {"-h",	     ".help",       XrmoptionNoArg,  (caddr_t) "True"},
    {"-help",	     ".help",       XrmoptionNoArg,  (caddr_t) "True"},
    {"-v",	     ".version",    XrmoptionNoArg,  (caddr_t) "True"},
    {"-version",     ".version",    XrmoptionNoArg,  (caddr_t) "True"},
    
    {"-leftkey",     "*leftkey",    	XrmoptionSepArg, (caddr_t) NULL},
    {"-leftkey1",    ".one.leftkey",    XrmoptionSepArg, (caddr_t) NULL},
    {"-leftkey2",    ".two.leftkey",    XrmoptionSepArg, (caddr_t) NULL},
    {"-rightkey",    "*rightkey",   	XrmoptionSepArg, (caddr_t) NULL},
    {"-rightkey1",   ".one.rightkey",   XrmoptionSepArg, (caddr_t) NULL},
    {"-rightkey2",   ".two.rightkey",   XrmoptionSepArg, (caddr_t) NULL},
    {"-upkey",       "*upkey",      	XrmoptionSepArg, (caddr_t) NULL},
    {"-upkey1",      ".one.upkey1",     XrmoptionSepArg, (caddr_t) NULL},
    {"-upkey2",      ".two.upkey2",     XrmoptionSepArg, (caddr_t) NULL},
    {"-downkey",     "*downkey",    	XrmoptionSepArg, (caddr_t) NULL},
    {"-downkey1",    ".one.downkey",    XrmoptionSepArg, (caddr_t) NULL},
    {"-downkey2",    ".two.downkey",    XrmoptionSepArg, (caddr_t) NULL},
    {"-alphakey",    "*alphakey",   	XrmoptionSepArg, (caddr_t) NULL},
    {"-alphakey1",   ".one.alphakey",   XrmoptionSepArg, (caddr_t) NULL},
    {"-alphakey2",   ".two.alphakey",   XrmoptionSepArg, (caddr_t) NULL},
    {"-betakey",     "*betakey",    	XrmoptionSepArg, (caddr_t) NULL},
    {"-betakey1",    ".one.betakey",    XrmoptionSepArg, (caddr_t) NULL},
    {"-betakey2",    ".two.betakey",    XrmoptionSepArg, (caddr_t) NULL},
    {"-quitkey",     "*quitkey",    	XrmoptionSepArg, (caddr_t) NULL},
    {"-quitkey1",    ".one.quitkey",    XrmoptionSepArg, (caddr_t) NULL},
    {"-quitkey2",    ".two.quitkey",    XrmoptionSepArg, (caddr_t) NULL},
};
static XrmDatabase r_rdb;
static XrmDatabase home_rdb;
static XrmDatabase server_rdb;
static XrmDatabase commandline_rdb;

XrmValue value;
char display_name[80];
char *str_type[40];

Option(argc,argv)
int argc;
char **argv;
{
    int p;

    /* xrm */
    XrmInitialize();

    /*ץäƤ*/
    XrmParseCommand(&commandline_rdb, option_table, number_of_option,
		"wot",&argc, argv);

    /*ǥץ쥤ץ³*/
    if (XrmGetResource(commandline_rdb, "wot.display",
		       "Wot.Display", str_type, &value) == True){
	    (void) strncpy(display_name, value.addr, (int) value.size);
	    display_name[value.size] = '\0';
	}else if (XrmGetResource(commandline_rdb, "wot.one.display",
		       "Wot.One.Display", str_type, &value) == True){
	    (void) strncpy(display_name, value.addr, (int) value.size);
	    display_name[value.size] = '\0';
	}else {
	    (void) strcpy(display_name, "");
	}
    
    if (!(display[0] = XOpenDisplay(display_name))){
	    (void) fprintf(stderr,"wot : Can't open display(%s)\n",
			   display_name);
	    exit(1);
	}
    
    /* إСΥǡ١ äƤ*/
    if (XResourceManagerString(display[0]) != NULL){
	    server_rdb =
		XrmGetStringDatabase(XResourceManagerString(display[0]));
	}
    
    /* ۡǥ쥯ȥΥǡ١äƤ*/
    {
        char filename[1024];

        (void) strcpy(filename, getenv("HOME"));
        (void) strcat(filename, "/.Xdefaults");
        home_rdb = XrmGetFileDatabase(filename);
    }

    /*餹٤ƤΥǡ١Ƥ*/
    XrmMergeDatabases(home_rdb, &r_rdb);
    XrmMergeDatabases(server_rdb, &r_rdb);
    XrmMergeDatabases(commandline_rdb, &r_rdb);


    /*Сɽ*/
    if (XrmGetResource(r_rdb, "wot.version",
		       "Wot.Version", str_type, &value) == True){
	printf("wot: Version %1.1f\n",PATCHLEVEL);
	exit(0);
    }
    
    /*إ*/
    if (XrmGetResource(r_rdb, "wot.help",
		       "Wot.Help", str_type, &value) == True || argc>2 ||
	XrmGetResource(r_rdb, "wot.two.display",
		       "Wot.Two.Display", str_type, &value)!= True && argc==1){
	printf("usage: wot [-options] [display]\n");
	printf("options  -display[n] -geometry[n] -fg[n] -bg[n] -rv[n] \n");
	printf("         -leftkey[n] -rightkey[n] -upkey[n] -downkey[n]\n");
	printf("         -alphakey[n] -betakey[n] -handicap\n");
	printf("         -size -map -help -version -iconic\n");
	printf("         n = Nothing or 1 or 2 \n");
	printf("Presented by IItom csis.oita-u.ac.jp\n");
	exit(0);

    }

    /*پä Ǥǥǥץ쥤ץ󤵤줿ǧ뤿*/
    display_name[0]='\0';

    /*ɥ⤦ͥץ*/
    if (argc==1 && XrmGetResource(r_rdb, "wot.two.display",
		       "Wot.Two.Display", str_type, &value) == True){
	(void) strncpy(display_name, value.addr, (int) value.size);
	display_name[value.size] = '\0';
    }else {
	(void) strcpy(display_name, argv[1]);
    }
    
    if (!(display[1] = XOpenDisplay(display_name))){
	(void) fprintf(stderr,"wot: Can not open display(%s)\n",
		       display_name);
	exit(1);
    }

    /*ɥȥ*/
    game_w_x[0]=0;
    game_w_y[0]=0;
    if (XrmGetResource(r_rdb, "wot.one.geometry",
		       "Wot.One.Geometry", str_type, &value) == True){
	char buffer[80];
	unsigned int w,h,x,y;
	int flag;
	
	for(p=0;p<PLAYERS;p++){
	    (void) strncpy(buffer, value.addr, (int) value.size);
	    buffer[value.size] = '\0';
	    flag=XGeometry(display[0],DefaultScreen(display[0]),
			   buffer,NULL,4,1,1,0,0,&x,&y,&w,&h);
	    if(flag&XValue)
		game_w_x[0]=x;
	    if(flag&YValue)
		game_w_y[0]=y;
	}
    }
    game_w_x[1]=0;
    game_w_y[1]=0;
    if (XrmGetResource(r_rdb, "wot.two.geometry",
		       "Wot.Two.Geometry", str_type, &value) == True){
	char buffer[80];
	unsigned int w,h,x,y;
	int flag;
	
	for(p=0;p<PLAYERS;p++){
	    (void) strncpy(buffer, value.addr, (int) value.size);
	    buffer[value.size] = '\0';
	    flag=XGeometry(display[1],DefaultScreen(display[1]),
			   buffer,NULL,4,1,1,0,0,&x,&y,&w,&h);
	    if(flag&XValue)
		game_w_x[1]=x;
	    if(flag&YValue)
		game_w_y[1]=y;
	}
    }
    
    
    /* ϥǥå */
    handicap=-1;
    if (XrmGetResource(r_rdb, "wot.handicap",
        "Wot.Handicap", str_type, &value) == True){
        char buffer[80];

        (void) strncpy(buffer,value.addr,(int) value.size);
        buffer[value.size] = '\0';
        handicap = atoi(buffer);
        if (handicap !=1 && handicap !=2){
            handicap = 0;
            (void) fprintf(stderr, 
			   "wot: handicap specification out of range\n");
	}
	--handicap;
    }
    
    /* 󥪥ץ*/
    icon_option=0;
    if (XrmGetResource(r_rdb, "wot.iconic",
		   "Wot.Iconic", str_type, &value) == True)
	icon_option=1;
	
    /*ǥե*/
    for(p=0;p<PLAYERS;p++){
	strcpy(foreground_name[p],"black");
	strcpy(background_name[p],"white");
    }

    /*   */

    if (XrmGetResource(r_rdb, "wot.one.foreground",
		       "Wot.One.Foreground", str_type, &value) == True ){
	(void) strncpy(foreground_name[0], value.addr, (int) value.size);
	foreground_name[0][value.size] = '\0';
    }
    if (XrmGetResource(r_rdb, "wot.two.foreground",
		       "Wot.Two.Foreground", str_type, &value) == True ){
	(void) strncpy(foreground_name[1], value.addr, (int) value.size);
	foreground_name[1][value.size] = '\0';
    }

    if (XrmGetResource(r_rdb, "wot.one.background",
		       "Wot.One.Background", str_type, &value) == True){
	(void) strncpy(background_name[0], value.addr, (int) value.size);
	background_name[0][value.size] = '\0';
    }
    if (XrmGetResource(r_rdb, "wot.two.background",
		       "Wot.Two.Background", str_type, &value) == True){
	(void) strncpy(background_name[1], value.addr, (int) value.size);
	background_name[1][value.size] = '\0';
    }



    /*ȿžץ*/

    if(XrmGetResource(r_rdb, "wot.one.reverseVideo",
		       "Wot.One.ReverseVideo", str_type, &value) == True){
	char tmp[80];
	    strcpy(tmp,foreground_name[0]);
	    strcpy(foreground_name[0],background_name[0]);
	    strcpy(background_name[0],tmp);
    }
    if(XrmGetResource(r_rdb, "wot.two.reverseVideo",
		       "Wot.Two.ReverseVideo", str_type, &value) == True){
	char tmp[80];
	    strcpy(tmp,foreground_name[1]);
	    strcpy(foreground_name[1],background_name[1]);
	    strcpy(background_name[1],tmp);
    }

    /*ɽϰ*/
    tile_number_x=7;
    tile_number_y=7;
    if (XrmGetResource(r_rdb, "wot.size",
        "Wot.Size", str_type, &value) == True){
        char buffer[80];
	int size;
	
        (void) strncpy(buffer,value.addr,(int) value.size);
        buffer[value.size] = '\0';
        size = atoi(buffer);
        if (size>=1 && size<=TILE_NUMBER_X/2){
	    tile_number_x=size*2+1;
	    tile_number_y=size*2+1;
	}else
	    fprintf(stderr,  "wot: size specification out of range\n");
    }

    /*ϥޥåפΥ桼*/
    beginmap=0;
    if (XrmGetResource(r_rdb, "wot.map",
        "Wot.Map", str_type, &value) == True){
        char buffer[80];
	int size;
	
        (void) strncpy(buffer,value.addr,(int) value.size);
        buffer[value.size] = '\0';
        beginmap = atoi(buffer);
        if (beginmap<1 || beginmap>MAP_NUMBER){
	    fprintf(stderr,  "wot: map specification out of range\n");
	    beginmap=0;
	}
    }
    
    /*Ѥ륭Υ桼*/

    if (XrmGetResource(r_rdb, "wot.one.rightkey",
		       "Wot.One.Rightkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        rightkey[0] = buffer[0];
    }
    if (XrmGetResource(r_rdb, "wot.two.rightkey",
		       "Wot.Two.Rightkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        rightkey[1] = buffer[0];
    }
    

    if (XrmGetResource(r_rdb, "wot.one.leftkey",
		       "Wot.One.Leftkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        leftkey[0] = buffer[0];
    }
    if (XrmGetResource(r_rdb, "wot.two.leftkey",
		       "Wot.Two.Leftkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        leftkey[1] = buffer[0];
    }


    if (XrmGetResource(r_rdb, "wot.one.downkey",
		       "Wot.One.Downkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        downkey[0] = buffer[0];
    }
    if (XrmGetResource(r_rdb, "wot.two.downkey",
		       "Wot.Two.Downkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        downkey[1] = buffer[0];
    }

    if (XrmGetResource(r_rdb, "wot.one.upkey",
		       "Wot.One.Upkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        upkey[0] = buffer[0];
    }
    if (XrmGetResource(r_rdb, "wot.two.upkey",
		       "Wot.Two.Upkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        upkey[1] = buffer[0];
    }


    if (XrmGetResource(r_rdb, "wot.one.alphakey",
		       "Wot.One.Alphakey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        alphakey[0] = buffer[0];
    }
    if (XrmGetResource(r_rdb, "wot.two.alphakey",
		       "Wot.Two.Alphakey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        alphakey[1] = buffer[0];
    }


    if (XrmGetResource(r_rdb, "wot.one.betakey",
		       "Wot.One.Betakey1", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        betakey[0] = buffer[0];
    }
    if (XrmGetResource(r_rdb, "wot.two.betakey",
		       "Wot.Two.Betakey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        betakey[1] = buffer[0];
    }


    if (XrmGetResource(r_rdb, "wot.one.quitkey",
		       "Wot.One.Quitkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        quitkey[0] = buffer[0];
    }
    if (XrmGetResource(r_rdb, "wot.two.quitkey",
		       "Wot.Two.Quitkey", str_type, &value) == True){
	char buffer[80];
	(void) strncpy(buffer, value.addr, (int) value.size);
        quitkey[1] = buffer[0];
    }
}
